﻿namespace U2UConsult.EF40.OptimisticConcurrency.Sample.Resources.Converters
{
    using System;
    using System.Windows.Data;

    /// <summary>
    /// Converts a SQL Server Timestamp value to a Double.
    /// </summary>
    /// <remarks>Probably not suited for very high values.</remarks>
    public class SqlTimestampToDoubleConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null)
            {
                return null;
            }

            byte[] bytes = value as byte[];
            double result = 0;
            double inter = 0;
            for (int i = 0; i < bytes.Length; i++)
            {
                inter = System.Convert.ToDouble(bytes[i]);
                inter = inter * Math.Pow(2, ((7 - i) * 8));
                result += inter;
            }

            return result;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
